﻿-- Isle of Thunder Weekly Check
-- by Fluffies
-- EU-Well of Eternity
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local ldbicon = ldb and LibStub("LibDBIcon-1.0", true)
local IoTMainframe

local iotwiicon = "Interface\\ICONS\\inv_qiraj_jewelglyphed"

local keylink -- Key to the Palace of Lei Shen - item
local ritualstone_name
local deng_itemname
local haqin_itemname
local vu_itemname
local rare_name = EXAMPLE_TARGET_MONSTER.." ("..ITEM_QUALITY3_DESC..")"

-- string colors
local LIGHT_RED   = "|cffFF2020"
local LIGHT_GREEN = "|cff20FF20"
local LIGHT_BLUE  = "|cff00ddFF"
local ZONE_BLUE   = "|cff00aacc"
local GREY        = "|cff999999"
local COORD_GREY  = "|cffBBBBBB"
local GOLD        = "|cffffcc00"
local WHITE       = "|cffffffff"
local PINK        = "|cffFFaaaa"
local function AddColor(str,color)
 return color..str.."|r"
end

local function DrawMainframe(frame, istooltip)

 local function completedstring(arg)
  if IsQuestFlaggedCompleted(arg) then
   return AddColor(COMPLETE,LIGHT_GREEN)
  else
   return AddColor(INCOMPLETE,LIGHT_RED)
  end
 end

-- title
 frame:ClearLines()
 frame:AddDoubleLine("Isle of Thunder Weekly Check","|T"..iotwiicon..":32|t")
 frame:AddLine(" ")
 frame:AddLine(" ")

 frame:AddDoubleLine(keylink, completedstring(32626))
 frame:AddLine(" ")
 frame:AddLine(ritualstone_name..":")
 frame:AddDoubleLine(" - "..AddColor(rare_name,WHITE), completedstring(32610))
 frame:AddDoubleLine(" - "..AddColor(select(8,GetAchievementInfo(8104)),WHITE), completedstring(32609))
 frame:AddLine(" ")
 frame:AddLine(AddColor(select(2,GetAchievementInfo(8110))..":", GOLD))
 frame:AddLine(" - "..deng_itemname)
 frame:AddDoubleLine(" - "..haqin_itemname, completedstring(32611))
 frame:AddLine(" - "..vu_itemname)
 frame:AddLine(" ")
 frame:AddDoubleLine(AddColor(GetAchievementCriteriaInfo(8105,1),WHITE), completedstring(32505))
 if not istooltip then
  frame:AddLine(" ")
  frame:AddLine(" ")
  --frame:AddLine(" ")
 end
end

local function CreateMainframe()
 if IoTMainframe and IoTMainframe:IsVisible() then
  IoTMainframe:Hide()
 else
  if not IoTMainframe then
   IoTMainframe = CreateFrame("GameTooltip", "IoTMainframe", nil, "GameTooltipTemplate")
  end
  
  IoTMainframe:SetOwner(UIParent,"ANCHOR_NONE")
  IoTMainframe:SetPoint("CENTER",UIParent,"CENTER")
  IoTMainframe:SetFrameStrata("HIGH")
  IoTMainframe:EnableMouse(true)
  IoTMainframe:SetMovable()
  IoTMainframe:SetScale(0.9)
  IoTMainframe:RegisterForDrag("LeftButton")
  IoTMainframe:SetScript("OnDragStart", function(self)  
		self:StartMoving()
  end)
  IoTMainframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing()
  end)
  
  DrawMainframe(IoTMainframe)

  if not IoTMainframe.Rabouttext then
   IoTMainframe.Rabouttext = IoTMainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
   IoTMainframe.Rabouttext:SetFont("Fonts\\FRIZQT__.TTF",8)
   IoTMainframe.Rabouttext:SetText(AddColor("                by",GREY)..
                                   AddColor(" Fluffies\n",LIGHT_BLUE)..
                                   AddColor(" EU-Well of Eternity",GREY))
   IoTMainframe.Rabouttext:SetPoint("BOTTOMRIGHT",IoTMainframe,"BOTTOMRIGHT",-5,5)
   IoTMainframe.Rabouttext:Show()
  end
 
  if not IoTMainframe.btnclose then
   IoTMainframe.btnclose = CreateFrame("Button", "iotwiclosebtn", IoTMainframe, "UIPanelButtonTemplate")
   IoTMainframe.btnclose:SetPoint("BOTTOM", IoTMainframe, "BOTTOM",0,10)
   IoTMainframe.btnclose:SetWidth(100)
   IoTMainframe.btnclose:SetText(CLOSE)
   IoTMainframe.btnclose:SetScript("OnClick", function(self)
    IoTMainframe:Hide()
    collectgarbage()
   end)
 end
 IoTMainframe:Show()
end
end

local ldbset = false
local eventframe = CreateFrame("FRAME","IoTWIEventFrame")
eventframe:RegisterEvent("VARIABLES_LOADED")
eventframe:RegisterEvent("GET_ITEM_INFO_RECEIVED")
local function eventhandler(self, event, ...)

 if event == "GET_ITEM_INFO_RECEIVED" then
  if keylink == nil then
   _, keylink = GetItemInfo(94222)
  end
  if ritualstone_name == nil then
   _, ritualstone_name = GetItemInfo(94221)
  end
  if deng_itemname == nil then
    _, deng_itemname = GetItemInfo(94233)
  end
  if vu_itemname == nil then
    _, vu_itemname = GetItemInfo(95350)
  end
  if haqin_itemname == nil then
    _, haqin_itemname = GetItemInfo(94130)
  end
 elseif event == "VARIABLES_LOADED" then
  _, keylink = GetItemInfo(94222)
  _, ritualstone_name = GetItemInfo(94221)
  _, deng_itemname = GetItemInfo(94233)
  _, haqin_itemname = GetItemInfo(94130)
  _, vu_itemname = GetItemInfo(95350)
  if IoTWeeklyItems_Options == nil then
   IoTWeeklyItems_Options = {}
  end
  if IoTWeeklyItems_Options["minimap_icon"] == nil then
    IoTWeeklyItems_Options["minimap_icon"] = {
        hide = false,
        minimapPos = 220,
    }
  end

  if ldb and not ldbset then
   local IoTWeeklyCheck = ldb:NewDataObject("IoTWeeklyCheck", {
	type = "data source",
	icon = iotwiicon,
	label = "IoT Weekly Check",
	OnClick = function(self,button)
         CreateMainframe()
	end,
	OnTooltipShow = function(tooltip)
		 DrawMainframe(tooltip,true)
	end,
   })
   if ldbicon then
    ldbicon:Register("IoTWeeklyCheck", IoTWeeklyCheck, IoTWeeklyItems_Options["minimap_icon"])
   end
   ldbset = true
  end -- variables_loaded
 end
end
eventframe:SetScript("OnEvent", eventhandler);

-- slash command
SLASH_IOTWEEKLYCHECK1 = "/iwc"
SlashCmdList["IOTWEEKLYCHECK"] = CreateMainframe